<?php
/*
Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
	require_once("utils.php");
	
	
	// constantes
	$eol		= ";\n";
	$filename	= "named.conf";
	define(TABSIZE,8);

/**********************/
/* 'Atomic functions' */
/**********************/
function is_notnull($var) {
	return strcmp($var,"");
}

function write_a_record($fp,$Name,$Ip) {
	if (strlen($Name)>=TABSIZE) {
		fwrite($fp,$Name."\tIN\tA\t".$Ip."\n");
	}
	else {
		fwrite($fp,$Name."\t\tIN\tA\t".$Ip."\n");
	}
}
function write_ptr_records($fp,$NameList,$PtrList,$ItemCount) {
	fwrite($fp,"\n\n");
	array_multisort($PtrList,$NameList);
	for ($i=0;$i<$ItemCount;$i++) {
		fwrite($fp,$PtrList[$i]."\t\tIN\tPTR\t".$NameList[$i].".\n");
	}
}
function write_cname_records($fp,$NameList,$AliasList,$ItemCount) {
	fwrite($fp,"\n\n");
	
	$ONameList     = array();
	$OAliasList    = array();

	$ONameList     = array_merge($ONameList,$NameList);
	$OAliasList       = array_merge($OAliasList,$AliasList);

	array_multisort($OAliasList,$ONameList);
	for ($i=0;$i<$ItemCount;$i++) {
		if (strcmp($OAliasList[$i],"") != 0) {
			if (strlen($OAliasList[$i])>=TABSIZE) {
				fwrite($fp,$OAliasList[$i]."\tIN\tCNAME\t".$ONameList[$i]."\n");
			}
			else {
				fwrite($fp,$OAliasList[$i]."\t\tIN\tCNAME\t".$ONameList[$i]."\n");
			}
		}
	}
}
function write_host_add($fp,$HostList,$IpList,$CommentsList,$ItemCount) {

	$OHostList     = array();
	$OIpList       = array();
	$OCommentsList = array();

	$OHostList     = array_merge($OHostList,$HostList);
	$OIpList       = array_merge($OIpList,$IpList);
	$OCommentsList = array_merge($OCommentsList,$CommentsList);
	
	array_multisort($OHostList,$OIpList,$OCommentsList);
	fwrite($fp,"\n\n");
	for ($i=0;$i<$ItemCount;$i++) {
		if (strcmp($OIpList[$i],"") != 0) {
			write_a_record($fp,$OHostList[$i],$OIpList[$i]);
			if (strcmp($OCommentsList[$i],"")!=0) {
				fwrite($fp,"\t\tIN\tTXT\t\"".$OCommentsList[$i]."\"\n");
			}
		}
	}
}

/*******************************************/
/* This function update the serial number  */
/* after having checked if there's changes */
/* The format choosen is YYYYMMDDRR        */
/* with RR the revision number             */
/*******************************************/
function write_timestamp($filetmp,$newfile,$path) {
	
	if (strcmp(substr($path,-1),"/") != 0 ) {
		$path=$path."/";
	}

	if (is_maj($filetmp,$path)) {
		if (file_exists($path.$newfile)) {
			$fp3=fopen($path.$newfile,"r");
			fgets($fp3,4096);
			$tmp=fgets($fp3,2);	// 2 tabulations 
			$Ymd=fgets($fp3,10);
			$serial=intval(fgets($fp3,4));
			fclose($fp3);
			unlink($path.$newfile);
		}
		$fp2=fopen($path.$filetmp,"r");
		$fp3=fopen($path.$newfile,"w+");

		fwrite($fp3,fgets($fp2,4096));
		fwrite($fp3,"\t\t".date(Ymd));
		if ( !strcmp(sprintf("%d",$Ymd),date(Ymd)) ) {
			$serial++;
			fwrite($fp3,sprintf("%02s",$serial));
		}
		else {
			fwrite($fp3,"00");
		}
		fwrite($fp3," ; serial\n");
		while (!feof($fp2)) {
			fwrite($fp3,fgets($fp2, 4096));
		}
		fclose($fp3);
	}
	else {
		del_old_conf($filetmp,$path);
	}																																    
}
/*****************************************************************/
/* This function returns all the subnets that are on the network */
/*****************************************************************/
function get_subnets($HostMgr) {

	$nb     = 0;
	$subnet = array();

	$r =& $HostMgr->get_list(LMS_HTYPE_UNKNOWN,array("iphostnumber"));
	$HostCount=$r->get_result('count');

	for ($i=0;$i<$HostCount;$i++) {
		$r =& $HostMgr->select_result($i);
		$Ips=$r->get_result('iphostnumber');
		foreach($Ips as $Ip) {
			$sub=get_subnet_from_ip($Ip);
			if (!in_array($sub,$subnet) && strcmp($sub,"0.0.0") ) {
				$subnet[$nb++]=$sub;
			}
		}
	}
	return $subnet;
}
/*********************************************************************************************/
/* Named.conf handling                                                                       */
/*********************************************************************************************/
function write_key($fp,$ini) {
	global $eol;

	fwrite($fp,"\nkey \"".$ini["named_header"]["key_type"]."\" {\n");
	fwrite($fp,"\talgorithm ".$ini["named_header"]["key_algo"].$eol);
	fwrite($fp,"\tsecret \"".$ini["named_header"]["key_secret"]."\"".$eol);
	fwrite($fp,"}".$eol);
}

function write_controls($fp,$ini) {
	global $eol;

	fwrite($fp,"\n\ncontrols {\n");

	$inet=explode(" ",$ini["named_header"]["controls_inet"]);
	fwrite($fp,"\tinet ".$inet[0]." port ".$inet[1]."\n");
	$allow=strtr($ini["named_header"]["controls_allow"],array(" "=>"; "));
	fwrite($fp,"\tallow { ".$allow."; } keys { \"".$ini["named_header"]["key_type"]."\"; }".$eol);
	fwrite($fp,"}".$eol);

}

function write_options($fp,$ini) {
	global $eol;

	fwrite($fp,"\n\noptions {\n");
	fwrite($fp,"\tdirectory \"".$ini["named_header"]["directory"]."\"".$eol);
	$xfer=explode(" ",$ini["named_header"]["allow_transfer"]);
	fwrite($fp,"\tallow-transfer {\n");
	for ($i=0;$i<count($xfer);$i++) {
		fwrite($fp,"\t\t".$xfer[$i].$eol);
	}
	fwrite($fp,"\t}".$eol);
	fwrite($fp,"\tallow-query {\n");
	fwrite($fp,"\t\t".$ini["named_header"]["allow_query"].$eol);
	fwrite($fp,"\t}".$eol);
	fwrite($fp,"\tdump-file \"".$ini["named_header"]["dump_file"]."\"".$eol);
	fwrite($fp,"\tpid-file \"".$ini["named_header"]["pid_file"]."\"".$eol);
	fwrite($fp,"\tstatistics-file \"".$ini["named_header"]["stats_file"]."\"".$eol);
	fwrite($fp,"\tmemstatistics-file \"".$ini["named_header"]["memstats_file"]."\"".$eol);
	fwrite($fp,"\tcheck-names master ".$ini["named_header"]["check_master"].$eol);
	fwrite($fp,"\tcheck-names slave ".$ini["named_header"]["check_slave"].$eol);
	fwrite($fp,"\tcheck-names response ".$ini["named_header"]["check_resp"].$eol);
	fwrite($fp,"\thost-statistics ".$ini["named_header"]["stats"].$eol);
	fwrite($fp,"\tdatasize ".$ini["named_header"]["datasize"].$eol);
	fwrite($fp,"\tstacksize ".$ini["named_header"]["stacksize"].$eol);
	fwrite($fp,"\tcoresize ".$ini["named_header"]["coresize"].$eol);
	fwrite($fp,"\tfiles ".$ini["named_header"]["files"].$eol);
	fwrite($fp,"\tnotify ".$ini["named_header"]["notify"].$eol);
	fwrite($fp,"\tauth-nxdomain ".$ini["named_header"]["auth_nxdomain"].$eol);
	fwrite($fp,"\ttransfers-in ".$ini["named_header"]["xfers_in"].$eol);
	fwrite($fp,"\ttransfers-per-ns ".$ini["named_header"]["xfers_ns"].$eol);
	fwrite($fp,"\ttransfers-out ".$ini["named_header"]["xfers_out"].$eol);
	fwrite($fp,"\tmax-transfer-time-in ".$ini["named_header"]["max_xfer_time"].$eol);
	fwrite($fp,"\ttransfer-format ".$ini["named_header"]["xfer_format"].$eol);
	$query=explode(" ",$ini["named_header"]["query_source"]);
	fwrite($fp,"\tquery-source address ".$query[0]." port ".$query[1].$eol);
	fwrite($fp,"\tcleaning-interval ".$ini["named_header"]["cleaning_inter"].$eol);
	fwrite($fp,"\tinterface-interval ".$ini["named_header"]["iface_inter"].$eol);
	fwrite($fp,"\tstatistics-interval ".$ini["named_header"]["stats_inter"].$eol);
	fwrite($fp,"\tprovide-ixfr ".$ini["named_header"]["provide_ixfr"].$eol);
	fwrite($fp,"}".$eol."\n");
}
function write_root_dns($fp,$ini) {
	$eol=";\n";

	fwrite($fp,"zone \".\" {\n");
	fwrite($fp,"\ttype forward".$eol);
	fwrite($fp,"\tforward only".$eol);
	$forwarders=strtr($ini["named_header"]["root_forwarders"],array(" "=>"; "));
	fwrite($fp,"\tforwarders { ".$forwarders."; }".$eol);
	fwrite($fp,"}".$eol."\n");
}

function write_zone($fp,$zone,$file,$is_master,$ini) {
	global $eol;
	
	fwrite($fp,"\nzone \"".$zone."\" IN {\n");
	if($is_master) {
		fwrite($fp,"\ttype master".$eol);
		fwrite($fp,"\tfile \"".$file."\"".$eol);
	}
	else {
		fwrite($fp,"\ttype forward".$eol."\tforward only".$eol);
		fwrite($fp,"\tforwarders { ");
		$tmp=explode(".",$file);
		$key=$tmp[0].".".$tmp[1].".".$tmp[2].".0";
		fwrite($fp,$ini["forwarders"][$key]);
		fwrite($fp," }".$eol);
	}
	fwrite($fp,"}".$eol."\n");
}

/* TODO */
function write_named_file() {
}
/*********************************************************************************************/
/* files *.zone handling                                                                     */
/*********************************************************************************************/
function write_zone_file_header($fp,$dn,$ini,$SrvMgr) {
	$Options=array("refresh","retry","expire","ttl");

        fwrite($fp,"@\t".$ini["zone_header"]["ttl"]);
	fwrite($fp,"\tIN\tSOA\tdns.".$dn.".\troot.dns.".$dn.". (\n");
	foreach($Options as $Opt){
		fwrite($fp,"\t\t".$ini["zone_header"][$Opt]." ; ".$Opt."\n");
	}
	fwrite($fp,"\t\t)\n");

	fwrite($fp,"@\tIN\tNS\tdns.".$dn.".\n");
	$r =& $SrvMgr->find('dns');
	$r =& $SrvMgr->select_result(0);
	$Count=count($r->get_result('servername'));
	for($i=2;$i<$Count+2;$i++) {
		fwrite($fp,"@\tIN\tNS\tdns".$i.".".$dn.".\n");
	}
	
	fwrite($fp,"@\tIN\tMX\t10\tmail\n\n");
	write_a_record($fp,"localhost","127.0.0.1");
	fwrite($fp,"\n");
}
function write_dns_a_records($fp,$HostMgr,$SrvMgr){
	
	$r =& $SrvMgr->find('dns');
	$r =& $SrvMgr->select_result(0);

	$prim=$r->get_result('primaryservername');
	$secs=$r->get_result('servername');
	
	$r =& $HostMgr->find($prim);
	$r =& $HostMgr->select_result(0);
	$Ips = $r->get_result('iphostnumber');
	write_a_record($fp,"dns",$Ips[0]);

	$nb=2;
	foreach($secs as $sec){
		$r =& $HostMgr->find($sec);
		$r =& $HostMgr->select_result(0);
		$Ips = $r->get_result('iphostnumber');
		write_a_record($fp,"dns".$nb,$Ips[0]);
		$nb++;
	}
	fwrite($fp,"\n\n");
}
/**********************************************************************************************/
/* file mysubnet.zone handling                                                                */
/**********************************************************************************************/
function write_zone_file($subnet,$HostMgr,$SrvMgr,$dn,$ini) {
	
	$file    = $subnet.".zone";
	$filetmp = $file.".tmp";
	$nb      = 0;
	
	$NameList= array();
	$PtrList = array();
	
	$fp=openconf($filetmp,$ini["outputdirs"]["dns"]);
								
	write_zone_file_header($fp,$dn,$ini,$SrvMgr);

	$r =& $HostMgr->get_list(LMS_HTYPE_UNKNOWN,array("iphostnumber","ismobilecomputer"));
	$HostCount=$r->get_result('count');
	
	for($i=0;$i<$HostCount;$i++) {
		$r =& $HostMgr->select_result($i);
		$Ips = $r->get_result('iphostnumber');
		$cn = $r->get_result('cn');
		foreach($Ips as $Ip){
			if ($r->get_result('ismobilecomputer') ) {
				$PtrList[$nb]=get_hostnbr_from_ip($Ip);
				$NameList[$nb++]=$cn."-".get_subnetnbr($subnet).".".$dn;
			}
			else {
				if (ip_belong_to_subnet($Ip,$subnet)) {
					$PtrList[$nb]=get_hostnbr_from_ip($Ip);
					if (count($Ips)>1) {
						$NameList[$nb++]=$cn."-".get_subnetnbr($subnet).".".$dn;
					}
					else {
						$NameList[$nb++]=$cn.".".$dn;
					}
				}
			}
		}
	}
	
	
	write_ptr_records($fp,$NameList,$PtrList,$nb);
	fclose($fp);
	write_timestamp($filetmp,$file,$ini["outputdirs"]["dns"]);
}

/*************************************************************************************/
/* Write the 127.0.0.zone file                                                       */
/*************************************************************************************/
function write_localhost($ini,$dn,$ini,$SrvMgr) {
	$zone    = "127.0.0.0";
	$subnet  = get_subnet_from_ip($zone);
	$file    = $subnet.".zone";
	$filetmp = $file.".tmp";

	$fp=openconf($filetmp,$ini["outputdirs"]["dns"]);
	write_zone_file_header($fp,$dn,$ini,$SrvMgr);
	write_ptr_records($fp,array("localhost"),array("1"),1);
	fclose($fp);
	write_timestamp($filetmp,$file,$ini["outputdirs"]["dns"]);
}


/*********************************************************************************************/
/* file mydomain.zone handling                                                               */
/*********************************************************************************************/
function write_dn_file($subnets,$HostMgr,$SrvMgr,$dn,$ini) {
	$file    = $dn.".zone";
	$filetmp = $file.".tmp";

	$HostNames    = array();
	$IpList       = array();
	$CommentsList = array();
	$AliasList    = array();
	$nb           = 0;
	
	$fp=openconf($filetmp,$ini["outputdirs"]["dns"]);
	
	write_zone_file_header($fp,$dn,$ini,$SrvMgr);
	write_dns_a_records($fp,$HostMgr,$SrvMgr);
	
	/* Fetch all infos for the commons hosts */
	$r =& $HostMgr->get_list(LMS_HTYPE_COMMON,array("iphostnumber","ismobilecomputer","dnsalias","description"));
	$HostCount=$r->get_result('count');
	for($i=0;$i<$HostCount;$i++) {
		$r      =& $HostMgr->select_result($i);
		$cn     = $r->get_result('cn');
		$Ip     = $r->get_result('iphostnumber');
		$mobile = $r->get_result('ismobilecomputer');
		$alias  = $r->get_result('dnsalias');
		$comment= $r->get_result('description');

		for($j=0;$j<count($subnets);$j++) {
			$subnet=get_subnet_from_ip($subnets[$j]);
			if ($mobile) {
				$IpList[$nb]=$subnet.".".get_hostnbr_from_ip($Ip[0]);
				$HostNames[$nb]=$cn."-".get_subnetnbr($subnet);
				$CommentsList[$nb]=$comment;
				if (ip_belong_to_subnet($Ip[0],$subnet)) {
					$AliasList[$nb++]=$cn;
					if (strcmp($alias,"") != 0){
						$HostNames[$nb]   = $cn;
						$IpList[$nb]      = "";
						$CommentsList[$nb]= "";
						$AliasList[$nb++] = $alias;
					}
				}
				else {
					$AliasList[$nb++]="";
				}
			}
			else if (ip_belong_to_subnet($Ip[0],$subnet)) {
				$IpList[$nb]=$Ip[0];
				$HostNames[$nb]=$cn;
				$CommentsList[$nb]=$comment;
				$AliasList[$nb++]=$alias;
			}
		}
	}	
	
	/* Fetch all infos for the servers */
	$r =& $HostMgr->get_list(LMS_HTYPE_SERVER,array("iphostnumber","dnsalias","description"));
	$HostCount=$r->get_result('count');
	for ($i=0;$i<$HostCount;$i++) {
		$r      =& $HostMgr->select_result($i);
		$cn     = $r->get_result('cn');
		$Ips    = $r->get_result('iphostnumber');
		$alias  = $r->get_result('dnsalias');
		$comment= $r->get_result('description');
		$psub   = 0;		// denotes if the alias for servers with
					// multiples Ips has been added in the list
		foreach ($Ips as $Ip) {
			for($j=0;$j<count($subnets);$j++) {
				$subnet=get_subnet_from_ip($subnets[$j]);
				if (ip_belong_to_subnet($Ip,$subnet)) {
					$IpList[$nb]=$Ip;
					$CommentsList[$nb]=$comment;
					if (count($Ips)>1) {
						$HostNames[$nb]=$cn."-".get_subnetnbr($subnet);
						if ($psub==0) {
							$AliasList[$nb++]=$cn;
							$HostNames[$nb]   = $HostNames[$nb-1];
							$IpList[$nb]      = "";
							$CommentsList[$nb]= "";
							$psub=1;
						}
						$AliasList[$nb++] = $alias;
					} 
					else {
						$HostNames[$nb]=$cn;
						$AliasList[$nb++] = $alias;
					}
				}
			}
		}
	}

	/* Get all services aliases */
	$r =& $SrvMgr->get_list(array('primaryservername','servername','dnsalias'));
	$Count = $r->get_result('count');
	$SrvMgr->sort_result_by_attr('cn');
	for ($i=0;$i<$Count;$i++) {
		$r        =& $SrvMgr->select_result($i);
		$pserver  = $r->get_result('primaryservername');
		$dnsalias = $r->get_result('dnsalias');
		if (strcmp($dnsalias[0],"")) {
			$dnsalias = array_filter($dnsalias,"is_notnull");
			$servers  = array($pserver);
			$servers  = array_merge($servers,$r->get_result('servername'));
			$servers  = array_merge(array_intersect($servers,$HostNames),array_intersect($servers,$AliasList));
			$servers  = array_filter($servers,"is_notnull");
			foreach($dnsalias as $alias) {
				$n=2;
				foreach($servers as $host) {
					$HostNames[$nb]=$host;
					$IpList[$nb]="";
					$CommentsList[$nb]="";
					if (!strcmp($host,$pserver)) {
						$AliasList[$nb++]=$alias;
					}
					else {
						$AliasList[$nb++]=$alias.$n;
						$n++;
					}
				}
			}
		}
	}
	
	write_host_add($fp,$HostNames,$IpList,$CommentsList,$nb);
	write_cname_records($fp,$HostNames,$AliasList,$nb);
	fclose($fp);
	write_timestamp($filetmp,$file,$ini["outputdirs"]["dns"]);

}
/************************************************************************************/
/* 'MAIN'                                                                           */
/*                                                                                  */
/************************************************************************************/
	
	// ouverture du fichier de parametrage
	$ini = parse_ini_file($ini_file,TRUE);

	if ($ini["general"]["die"]) {
		exit(2);
	}
	
	$langmgr =& new DftkDaLanguageManager();
	$resultmgr =& new DftkDaTraceManager($langmgr);
	
	$con =& new DftkLdapConnection($resultmgr);
	$con->set_wrapping_parameter($config[base], "ou=Users", "ou=CommonUsers", "ou=AdminUsers", "ou=ServiceUsers");
	
	$r =& $con->connect($config[server], true);
	if ($r->has_error()) {
		print($r->get_debug_msg(true));
		exit(1);
	}
	
	$r =& $con->bind( $config[login],$config[passwd]);
	if ($r->has_error()) {
		print($r->get_debug_msg(true));
		exit(1);
	}
	
	$HostMgr =& new LmsHostManager      ($resultmgr, $con);
	$SrvMgr  =& new LmsServiceManager   ($resultmgr, $con);
	
	$dn=ds2dn($config[base]);
	
	$subnet = get_subnets($HostMgr);

	$fp=openconf($filename.".tmp",$ini["outputdirs"]["dns"]);

	write_key($fp,$ini);
	write_controls($fp,$ini);
	write_options($fp,$ini);
	write_root_dns($fp,$ini);
	$zone=rev_ip_domain(get_subnet_from_ip("127.0.0.0")).".in-addr.arpa";
	write_zone($fp,$zone,get_subnet_from_ip("127.0.0.0").".zone",true,$ini);
	write_zone($fp,$dn,$dn.".zone",true,$ini);

	$i=0;
	$subnets=array();
	foreach($ini["forwarders"] as $key => $value) {
		$subnets[$i]=$key;
		$i++;
	}

	$j=0;
	for($i=0;$i<count($subnet);$i++) {
		$zone=rev_ip_domain($subnet[$i]).".in-addr.arpa";
		if (in_array($subnet[$i].".0",$subnets)) {
			write_zone($fp,$zone,$subnet[$i].".zone",false,$ini);
		}
		else {
			write_zone($fp,$zone,$subnet[$i].".zone",true,$ini);
			$tmp[$j++]=$subnet[$i];
		}
	}
	unset($subnets);
	$subnets=$tmp;
	
	// fermeture du fichier
	fclose($fp);

	write_localhost($ini,$dn,$ini,$SrvMgr);
	write_dn_file($subnets,$HostMgr,$SrvMgr,$dn,$ini);

	for ($j=0;$j<count($subnets);$j++) {
		$master_subnet = get_subnet_from_ip($subnets[$j]);
		write_zone_file($master_subnet,$HostMgr,$SrvMgr,$dn,$ini);
	}
	// fermeture de la connection ldap
	$con->disconnect();
	
	// verification des fichiers afin de savoir si on doit faire une M.A.J.
	$path=$ini["outputdirs"]["dns"];
	if (is_maj($filename.".tmp",$path)) {	
		if (strcmp(substr($path,-1),"/") != 0 ) {
			$path=$path."/";
		}
		copy($path.$filename.".tmp",$path.$filename);
	}
	else {
		del_old_conf($filename.".tmp",$path);
	}
	

	if ($ini["general"]["gen_only"]) {
		exit(3);
	}

?>
